<template>
  <div>
    <LHeader :text="text"></LHeader>
    <van-search v-model="searchValue" placeholder="搜索" @search="onSearch" />
    <!-- 内容列表 -->
    <div class="con-list">
      <van-cell-group
        inset
        v-for="(item, index) in messageList"
        :key="index"
        @touchstart="touchstart(index, item)"
        @touchend.prevent="touchend(index)"
      >
        <van-row gutter="">
          <van-col span="5">所属项目:</van-col>
          <van-col span="19">{{ item.proId }}</van-col>
        </van-row>
        <van-row gutter="">
          <van-col span="5">隐患级别:</van-col>
          <van-col span="19">{{ item.hdLev }}</van-col>
        </van-row>
        <van-row gutter="">
          <van-col span="5">适用范围:</van-col>
          <van-col span="19">{{ item.hdRange }}</van-col>
        </van-row>
        <van-row gutter="">
          <van-col span="5">隐患类型:</van-col>
          <van-col span="19">{{ item.hdType }}</van-col>
        </van-row>
        <van-row gutter="">
          <van-col span="5">发现时间:</van-col>
          <van-col span="19">{{ item.hdDiscoveryTime }}</van-col>
        </van-row>
        <van-row gutter="">
          <van-col span="5">超期标识:</van-col>
          <van-col span="19">{{ item | formatTime }}</van-col>
        </van-row>
        <van-row gutter="">
          <van-col span="5">状态:</van-col>
          <van-col span="19">{{ item.taskName }}</van-col>
        </van-row>


        <!-- 长按显示遮罩层 -->
        <van-overlay :show="showIndex == index">
          <div class="wrapper" @click.stop>
            <van-button round type="primary" @touchstart="goDetail(item)"
              >详情</van-button
            >
          </div>
        </van-overlay>
      </van-cell-group>
    </div>
  </div>
</template>

<script>
import LHeader from "@/components/header.vue";
import { dangerStandBook } from "@/service/danger";
export default {
  components: {
    LHeader,
  },
  data() {
    return {
      text: "隐患历史台账",
      searchValue: "",
      messageList: [],
      Loop: "", // 定时器
      showIndex: null // 是否显示遮罩层
    };
  },
  created() {
    this.postList();
  },
  methods: {
    onSearch(val) {
      console.log(val);
    },

    postList() {
      this.$toast.loading({
        message: "加载中...",
        forbidClick: true,
        loadingType: "spinner",
        duration: 0
      });
      dangerStandBook("/hdreport/doneList")
        .then(res => {
          this.$toast.clear();
          this.messageList = res.rows;
        })
        .catch(() => {
          this.$toast.clear();
          this.$toast.fail("加载失败,请稍后再试");
        });
    },

    touchstart(index, item) {
      clearTimeout(this.Loop); //再次清空延时器，防止重复注册定时器
      if (this.showIndex != null) {
        this.showIndex = null;
        return;
      }
      this.Loop = setTimeout(() => {
        this.showIndex = index;
      }, 300); // 这里的1000是指需要长按的时间，单位为ms
    },
    touchend(index) {
      // 这个方法主要是用来将每次手指移出之后将计时器清零
      clearInterval(this.Loop);
    },

    // 详情
    goDetail(data) {
      console.log(data);
      this.$router.push({
          name: "normal-detail",
          params:{
            id: data.businessId
          }
      });
      this.showIndex = null;
    },
  },
  filters: {
    formatTime: function(row) {
          if (row.dueDate <= row.rectificationTime) {
              return "超期"
          } else if (row.dueDate >= row.rectificationTime && row.dueDate - 259200000 <= row.rectificationTime) {
              //三天
              return "临期"
          } else {
              return "正常"
          }
    }
  }
};
</script>
<style lang="less" scoped>
/* @import url(); 引入css类 */
.con-list {
  padding: 10px 10px .533333rem;
  background-color: #f0f1f5;
  .van-cell-group--inset {
    margin: 0;
    margin-bottom: 10px;
    padding: 10px;
    font-size: 13px;
    position: relative;
    .van-row{
      margin-bottom: .133333rem;
      line-height: .64rem;
    }
    .van-overlay {
      position: absolute;
      .wrapper {
        display: flex;
        align-items: center;
        justify-content: space-evenly;
        height: 100%;
      }
    }
  }
}
</style>
